#!/usr/bin/perl

BEGIN { push (@INC,'/qos/modules'); }
use qos_config ;
$DEBUG=YES ;
undef $DEBUG ;
use RRDs ;
use CGI qw (:standard) ;

# Check for the rrd-locatie directory
if ( ! -d $RRDS ) {
	print "$RRDS : directory not found, Exitting\n" ;
	exit ;
}

$uptime = `uptime` ;
@uptime = split " ", $uptime ;
$uptime[-3] =~ s/\.// ;
$uptime[-3] =~ s/,// ;
$uptime[-3] = $uptime[-3] * 300 ;
#print "$uptime[-3]\n" ;

$date = `date +%s` ;

$rrd = $RRDS . "/" . "eth0" . ".uptime" ;

update_rrd ($rrd,$uptime[-3],0,0,0,0,0,0,0,0) ;

# Update rrd
# Called for each qdisc/class and each interface
sub update_rrd () {
	@input = @_ ;
	$rrd_base = shift @input ;

	$rrd = $rrd_base . ".1.rrd" ;
	if ( ! -f $rrd ) {
		RRDs::create ($rrd,
			"DS:by:DERIVE:600:0:U",
			"DS:pa:DERIVE:600:0:U",
			"DS:dr:DERIVE:600:0:U",
			"DS:ov:DERIVE:600:0:U",
			"RRA:MIN:0.5:1:576","RRA:MIN:0.5:6:576","RRA:MIN:0.5:24:576","RRA:MIN:0.5:288:576",
			"RRA:MAX:0.5:1:576","RRA:MAX:0.5:6:576","RRA:MAX:0.5:24:576","RRA:MAX:0.5:288:576",
			"RRA:AVERAGE:0.5:1:576","RRA:AVERAGE:0.5:6:576","RRA:AVERAGE:0.5:24:576","RRA:AVERAGE:0.5:288:576"
		) ;
		$err = RRDs::error;
		print "Error while creating $rrd : $err\n" if $err ;
	}
	print "Updating $rrd\n  with $input[0]:$input[1]:$input[2]:$input[3]\n" if $DEBUG ;
	RRDs::update ("$rrd","$date:$input[0]:$input[1]:$input[2]:$input[3]");
	$err = RRDs::error;
	print "Error while updating $rrd : $err\n" if $err ;
}
