#!/usr/bin/perl

BEGIN { push (@INC,'/qos/modules'); }

use CGI qw (:standard) ;
use Data::Dumper ;
use qos_config ;
use qos ;
use htb ;

$cgi = url () ;

$submit  = param('submit') ;
$type    = param('type') ;
$mark    = param('mark') ;
$rule    = param('rule') ;
$dest    = param('dest') ;
$prio    = param('prio') ;
$name    = param('name') ;
$parent  = param('parent') ;

read_config1 () ;
read_config2 () ;
read_config3 () ;
read_config4 () ;

# Edit a filter rule
if ( $submit eq "edit" ) {
	# Show the filter you want to edit
	if ( ! defined $type ) {
		print header () ;
		print start_html (-title=>"QOS configrator",-style=>{'code'=>"$CSS"}) ;
		show_filter ($parent,$name) ;
		print end_html () ;
		exit ;
	# Save the edited filter rule
	} else {
		$filter->{$parent}{$name}{type} = $type ;
		# Prio must be number between 0 and 7
		# First number is used, so prio 329 becomes 3
		if ( $prio ne "" ) {
			$prio =~ s/([01234567])// 
				and $filter->{$parent}{$name}{prio} = $1 
				or $ERR = "Prio must be a number between 0 and 7" ;
		# If no prio number was entered, clear the prio option
		} else { delete $filter->{$parent}{$name}{prio} ; }
		$filter->{$parent}{$name}{dest} = $dest ;
		$filter->{$parent}{$name}{mark} = $mark ;
		$filter->{$parent}{$name}{rule} = $rule ;
		write_config3 () ;
	}

# Delete a filter
} elsif ( $submit eq "delete" ) {
	# Show the filter to delete get a confirmation from the user
	if ( ! defined $type ) {
		print header () ;
		print start_html (-title=>"QOS configrator",-style=>{'code'=>"$CSS"}) ;
		$type = $filter->{$parent}{$name}{type} ;
		$dest = $filter->{$parent}{$name}{dest} ;
		$prio = $filter->{$parent}{$name}{prio} ;
		$mark = $filter->{$parent}{$name}{mark} ;
		$rule = $filter->{$parent}{$name}{rule} ;
		show_filter ($parent,$name) ;
		print end_html () ;
		exit ;
	# Delete the filter
	} else {
		delete $filter->{$parent}{$name} ;
		write_config3 () ;
	} 
# Add a new filter
} elsif ( $submit eq "Add new filter" ) {
	# If we have a name, add the new filter 
	if ( defined $name ) {
		# Check if the name is not already used
		if ( defined $filter->{$parent}{$name} ) {
			$ERR = "Filter already exists." ;
		# Check if we really got a name
		} elsif ( $name eq "" ) {
			$ERR = "No name given" ;
		# Process the options
		} else {
			$filter->{$parent}{$name}{type} = $type ;
			$filter->{$parent}{$name}{dest} = $dest ;
			# Prio must be number between 0 and 7
			# First number is used, so prio 329 becomes 3
			if ( $prio ne "" ) {
				$prio =~ s/([01234567])//
					and $filter->{$parent}{$name}{prio} = $1 
					or $ERR = "Prio must be a number between 0 and 7" ;
			# If no prio number was entered, clear the prio option
			} else { delete $filter->{$parent}{$name}{prio} ; }
			write_config3 () ;
		}
	# Show the forms so the user can add a new filter configuration
	} else {
		print header () ;
		print start_html (-title=>"QOS configrator",-style=>{'code'=>"$CSS"}) ;
		show_filter ($parent) ;
		exit ;
	}
}

print header () ;
print start_html (-title=>"QOS configrator",-style=>{'code'=>"$CSS"}) ;

# If we had an error, show it to the user
print "<h1>Error</h1>\n" if defined $ERR ;
print $ERR if defined $ERR ;

# Process all enabled devices
foreach $dev (keys(%{$main->{NIC}})) {
	next if $main->{NIC}{$dev} =~ /off/ ;
	# Show the htb configuration so know how we have to filter
	print "<h1>Device $dev</h1>\n" ;
	$overview = "yes" ; # We have to set this option so the next function show only an overview
	process_device_saved  ("$dev") ; # Print the configuration
	print "<p>\n<table celpadding=0 cellspacing=0 border=1>\n";
	print "<tr><th>name</th>" ;
	print "<th>parent</th>" ;
	print "<th>type</th>" ;
	print "<th>destination</th>" ;
	print "<th>prio</th>" ;
	print "<th>option</th>" ;
	print "<th colspan=2>action</th>" ;
	print "</tr>\n" ;

	# The first pass of the find_filters function needs a @all_leaf_childs variable
	@all_leaf_childs = @{$htb->{$dev}{all_leaf_childs}} ;
	find_filters ($dev) ;

	print "</table>\n<p>\n" ;

	# Add a "Add new filter" button
	print startform () ;
	print submit (-name=>'submit',-value=>"Add new filter") ;
	print hidden (-name=>'parent',-override=>"1",-value=>$dev) ;
	print endform () ;
}

print "<p>TODO<br>choice of starting point for a filter\n" ;
print "<br>use dot to graph an overview\n" ;
write_config3_debug () if defined $DEBUG ;

docum_org () ;
print end_html () ;

# This function processes all classes and child classes and shows all found filters
sub find_filters {
	$class = $_[0] ;
	if ( defined $filter->{$class} ) { # If the class is defined, find all the filters
	foreach my $name (sort(keys(%{$filter->{$class}}))) { # Process all find filters
		print "<tr>\n" ;
		print "<td>$name</td>" ;
		print "<td>$class</td>" ;
		print "<td>$filter->{$class}{$name}{type}</td>" ;

		# Destination of filter must be a leaf class.
		$color = "red" ;
		foreach $all_leaf_childs (@all_leaf_childs) {
			if ( $all_leaf_childs eq $filter->{$class}{$name}{dest} ) {
				# If the destination of the filter is a valid child class, remove the red color
				$color = "black" ;
			}
		}
		print "<td><font color=$color>$filter->{$class}{$name}{dest}</font></td>" ;

		if ( $filter->{$class}{$name}{prio} ne "" ) {
			print "<td>$filter->{$class}{$name}{prio}</td>" ;
		} else {
			print "<td>&nbsp;</td>" ;
		}

		# There are 2 types of filter.  Each type has it's own options.
		if ( $filter->{$class}{$name}{type} eq "fw" ) {
			if ( $filter->{$class}{$name}{mark} ne "" ) {
				print "<td>$filter->{$class}{$name}{mark}</td>" ;
			} else {
				print "<td>&nbsp;</td>" ;
			}
		} elsif ( $filter->{$class}{$name}{type} eq "u32" ) {
			if ( $filter->{$class}{$name}{rule} ne "" ) {
				if ( $u32->{$filter->{$class}{$name}{rule}} ) {
					print "<td>$filter->{$class}{$name}{rule}</td>" ;
				} else {
					print "<td><font color=red>$filter->{$class}{$name}{rule}</font></td>" ;
				}
			} else {
				print "<td>&nbsp;</td>" ;
			}
		} else {
			print "<td>&nbsp;</td>" ;
		}

		# Add some buttons
		print "<td>";
		print startform () ;
		print submit (-name=>'submit',-value=>"delete") ;
		print hidden (-name=>'name',-override=>"1",-value=>$name) ;
		print hidden (-name=>'parent',-override=>"1",-value=>$class) ;
		print endform () ;
		print "</td>\n" ;
		print "<td>";
		print startform () ;
		print submit (-name=>'submit',-value=>"edit") ;
		print hidden (-name=>'name',-override=>"1",-value=>$name) ;
		print hidden (-name=>'parent',-override=>"1",-value=>$class) ;
		print endform () ;
		print "</td>\n" ;
		print "</tr>\n" ;
	}
	}

	# Repeat the above for ahh child classes
	my @childs = @{$htb->{$class}{childs}} ;
	foreach $class (@childs) {
		find_filters ($class) ;
	}
}

# Show the filter rule info
sub show_filter {
	($parent,$name) = @_ ;
	print startform () ;

	print "<p>\n<table celpadding=0 cellspacing=0 border=1>\n";
	print "<tr><th>Name</td><td class=left>\n" ;
	if ( defined $name ) { print "$name" ;
		print hidden (-name=>"name",
			-override=>1,
			-value=>$name) ;
	} else { print textfield (-name=>"name",
			-override=>1,
			-value=>$name) ;
	}

	print "<tr><th>Parent</td><td class=left>\n" ;
	if ( defined $parent ) { print "$parent" ;
		print hidden (-name=>"parent",
			-override=>1,
			-value=>$parent) ;
	} else { print textfield (-name=>"parent",
			-override=>1,
			-value=>$parent) ;
	}

	print "<tr><th>Type</td><td class=left>\n" ;
	if ( defined $type ) { print "$type" ;
		print hidden (-name=>"type",
			-override=>1,
			-value=>$type) ;
        } else { print popup_menu (-name=>"type",
			-values=>["u32","fw"],
			-default=>$filter->{$parent}{$name}{type}) ;
	}

	print "<tr><th>Destination</td><td class=left>\n" ;
	if ( defined $dest ) { print "$dest" ;
		print hidden (-name=>"dest",
			-override=>1,
			-value=>$dest) ;
	} else { print popup_menu (-name=>"dest",
			-override=>1,
			-values=>[@{$htb->{$parent}{all_leaf_childs}}] );
	}

	print "<tr><th>prio</td><td class=left>\n" ;
	if ( defined $prio ) { print "$prio" ;
		print hidden (-name=>"prio",
			-override=>1,
			-value=>$prio) ;
	} else { print textfield (-name=>"prio",
			-override=>1,
			-value=>$filter->{$parent}{$name}{prio},
			-size=>"2" ) ;
	}

	if ( ( $filter->{$parent}{$name}{type} eq "fw" ) or ( $type eq "fw" ) ) {
		print "<tr><th>Firewall mark " . help ("fw") . "</td><td class=left>\n" ;
		if ( defined $mark ) { print "$mark" ;
			print hidden (-name=>"mark",
				-override=>1,
				-value=>$mark) ;
		} else { print textfield (-name=>"mark",
				-size=>5,
				-override=>1,
				-default=>$filter->{$parent}{$name}{mark} );
		}
	} elsif ( ( $filter->{$parent}{$name}{type} eq "u32" ) or ( $type eq "u32" ) ) {
		print "<tr><th>Filter rule</td><td class=left>\n" ;
		if ( defined $rule ) { print "$rule" ;
			print hidden (-name=>"rule",
				-override=>1,
				-value=>$rule) ;
		} else { 
			@values = sort (keys(%{$u32}) ) ;
			print popup_menu (-name=>"rule",
				-size=>1,
				-override=>1,
				-default=>$filter->{$parent}{$name}{rule},
				-values=>[@values]);
		}
	}

	print "</td></tr>\n<tr><th colspan=2>" ;
	print submit (-name=>'submit',-value=>"$submit") ;
	print "</th></tr>\n ";

        print "</table>\n" ;

	print endform () ;
}

