#!/usr/bin/perl

# This scripts show some simple help pages.

BEGIN { push (@INC,'/qos/modules'); }

use CGI qw (:standard) ;
use qos_config ;
use qos ;
$action  = param('submit') ;

if ( $action =~ /prio/ ) {
	$help .= "Prio determines how remaining bandwidth (after each class gets his rate) is divided.  The class with the lowest prio will be the first to get the bandwidth it needs.\n" ;
	$help .= "<ul>" ;
}

if ( $action =~ /rate/ ) {
	$TITLE = "Rate" ;
	$help .= "Rate is the minimum bandwidth a class gets.\n" ;

	$help .= "<p>Possible answers :\n" ;
	$help .= "<ul>" ;
	$help .= "<li>Blanco : auto calculated\n" ;
	$help .= "</ul>" ;

	$help .= "<p>Extra information :\n" ;
	$help .= "<ul>" ;
	$help .= "<li>Link = rate = link bandwidth" ;
	$help .= "</ul>" ;
}

if ( $action =~ /major-number/ ) {
	$TITLE = "Root qdisc major number" ;
	$help .= "The root qdisc is the mechanism that's used to send the packets that leaves a device.  It needs a \"major number\".  You can give 2 different devices the same major number.\n" ;
}

if ( $action =~ /qdisc/ ) {
	$help .= "The qdisc attached to a class is responsible for sending the packets.  The sfq qdisc is designed to give each data stream in the class the same opportunity to send.\n" ;
	$help .= "If you choose none, the standard qdisc (a prio one) will be used.\n" ;
}

if ( $action =~ /ceil/ ) {
	$TITLE = "Ceil" ;
	$help .= "Ceil is the maximum bandwidth the class can ever get" ;

	$help .= "<p>Possible answers :\n" ;
	$help .= "<ul>" ;
	$help .= "<li>LINK : link bandwidth\n" ;
	$help .= "<li>Blanco : ceil = rate\n" ;
	$help .= "</ul>" ;

	$help .= "<p>Extra information :\n" ;
	$help .= "<ul>" ;
	$help .= "<li>Link = ceil = link bandwidth" ;
	$help .= "<li>Rate = ceil = rate of cmlss" ;
	$help .= "<li>PCeil = ceil = ceil of the parent" ;
	$help .= "</ul>" ;
} 
 
if ( ( $action =~ /ceil/ ) or ( $action =~ /rate/ )  or ( $action =~ /bandwidth/ ) ) {
	$help .= "<p>bps = byte / second<br>\n" ;
	$help .= "bit = bit / second<br>\n" ;
	$help .= "<p>So 10 kbps = 10 kilobyte / second" ;
	$help .= "<p>The number is always stored as kbps (kilobyte/s) in the config files." ;
}

if ( $action =~ /bandwidth/ ) {
	$TITLE = "Bandwidth" ;
	$help .= "This is the maximum bandwidth you can send with the device.  So if you have a 128 kbps connection to the internet connected to your eth0, you have to configure the outgoing bandwidth as 128 kbps.\n"  ;
}

if ( $action =~ /fw/ ) {
	$TITLE = "FW Filter" ;
	$help .= "This filter can be used in combination with iptables or ipchains.  If you mark packets, you can use this mark with the fw filter.\n" ;
}

if ( ( $action =~ /fw/ ) or ( $action =~ /u32/ ) ) {
	$help .= "<br>Use \",\" as a separator key.  You can specify a range with a -.  So 1-4,8 means 1,2,3,4 and 8.\n" ;
}

print header () ;
print start_html (-title=>"QOS Configurator",-style=>{'code'=>"$CSS"}) ;
if ( $TITLE ) { 
	print "<h1>$TITLE</H1>\n" ;
} else {
	print "<h1>$action</H1>\n" ;
}
print $help ;
print end_html () ;
