#!/usr/bin/perl

BEGIN { push (@INC,'/qos/modules'); }

use CGI qw (:standard) ;
use Data::Dumper ;
use qos_config ;
use qos ;
use htb ;

#$DEBUG = yes ;
$cgi = url () ;

$submit  = param('submit') ;
$action  = param('action') ;
$parent  = param('parent') ;
$device  = param('device') ;
$name    = param('name') ;
$rate    = param('rate') ;
$ceil    = param('ceil') ;
$comm    = param('comm') ;
$prio    = param('prio') ;
$qdisc   = param('qdisc') ;
$show    = param('show') ;
$password= param('password') ;
$default = param('default') ;

#print header () ;
#print start_html (-title=>"QOS configrator",-style=>{'code'=>"$CSS"}) ;

# The find_tree.pl command processes the output of the tc command and creates a config file.  This scripts uses a special tc binary so it can be execute with the uid of the web-server.
if ( $submit eq "refresh" ) {
	system "$BIN/find_tree.pl" ;

# Set the default class in the htb configuration
} elsif ( $submit eq "default" ) {
	read_config1 () ;
	$main->{$device}{default} = $default ;
	write_config1 () ;

# Delete a class
} elsif ( $action eq "do_delete" ) {
	read_config1 () ;
	read_config2 () ;
	$temp = $device . ":" . $name ;
	# Create a good parent.  If the parent is not the device, the devices must be added to the parent variable.
	if ( ( defined $parent ) and ( $parent != $device ) ) {
		$parent = $device . ":" . $parent ;
	} else {
		$parent = $device ;
	}

	# We also have to filter out the child out of the list of childs of the parent
	foreach $ele (@{$htb->{$parent}{childs}}) {
		if ( $ele ne $temp ) {
		push @temp, $ele ;
		}
	}
	@{$htb->{$parent}{childs}} = @temp ;

	delete_class ($temp) ; # delete all classes depending on this class
	write_config2 () ;

# Ask the user if he wants to delete a class
} elsif ( $submit eq "delete" ) {
	$submit = "delete" ; # To show a delete button when we show the class info
	$action = "do_delete" ; # I had some problems to found out when I had to delete the class, so I used an extra variable
	print header () ;
	print start_html (-title=>"QOS configrator",-style=>{'code'=>"$CSS"}) ;
	read_config1 () ;
	read_config2 () ;
	$parent = ( $htb->{$name}{parent} or "&nbsp;" ) ;
	$prio   = ( $htb->{$name}{prio} or "&nbsp;" ) ;
	$qdisc  = ( $htb->{$name}{qdisc} or "&nbsp;" ) ;
	$rate   = ( $htb->{$name}{rate} or "&nbsp;" ) ;
	$ceil   = ( $htb->{$name}{ceil} or "&nbsp;" ) ;
	$comm   = ( $htb->{$name}{comm} or "&nbsp;" ) ;
	show_class ($name) ;
	docum_org () ;
	print end_html () ;
	exit ;

# Add a new class
} elsif ( $submit eq "submit" ) {
	# Only do something when we have a name defined
	if ( defined $name ) {
		read_config2 () ; # Read config
		# Clean up the variables
		$name =~ s/\s//g ; # don't allow spaces in names so remove them

		if ( $name =~ /^[1234567890abcdef]{1,4}$/ ) { # A name my only contain digits and letters a - f

		$name = $device . ":" . $name ;

		# Check if we have already a class with the same name if we define a new class
		if ( ( defined $htb->{$name}{qdisc} ) and ( $action eq "add_new_class" ) ) {
			$ERR = "Class $name allready exists\n" ;
		} else {
			$rate = check_rate ($rate) ;

			if ( ! $ceil ) {
				# If we add a new class, default ceil = LINK, otherwise, ceil is not defined
				if ( $action eq "add_new_class" ) {
					$ceil = "LINK" ;
				} else {
					undef $ceil ;
				}
			} elsif ( $ceil =~ /LINK/i ) {
				$ceil = "LINK" ;
			} else {
				$ceil = check_speed ($ceil) ;
			}

			# Commit the data
			if ( ( ! defined $parent ) or ( $parent eq $device ) ) {
				$parent = $device ; # For the first class on a device, we have no parent or parent = device, so parent = device
			} else {
				$parent = $device . ":" . $parent ;
			}
			$htb->{$name}{parent} = $parent ;

			# Check the rate and ceil for errors
			if ( $ceil ne "" ) {
				if ( $ceil eq "LINK" ) {
					$htb->{$name}{ceil} = $ceil ;
				} elsif ( ( $ceil > $htb->{$parent}{CEIL} ) and ( $htb->{$parent}{CEIL} ne "" ) ) {
					$ERR = "Ceil ($ceil) is bigger then the ceil of the parent $parent ($htb->{$parent}{CEIL})." ;
				} elsif ( ( $htb->{$name}{RATE} ne "" ) and ( $ceil < $htb->{$name}{RATE} ) ) {
					$ERR = "Ceil ($ceil) is smaller then the rate ($htb->{$name}{RATE})." ;
				} else {
					$htb->{$name}{ceil} = $ceil ;
				}
			} else { delete $htb->{$name}{ceil} ; }

			if ( $rate ne "" ) {
				if ( ( $rate > $htb->{$parent}{RATE} ) and ( $htb->{$parent}{RATE} ne "" ) ) {
					$ERR = "Rate ($rate) is bigger then the rate of the parent ($htb->{$parent}{RATE}) ." ;
				} elsif ( ( $ceil ne "" ) and ( $htb->{$name}{CEIL} ne "" ) and ( $rate > $htb->{$name}{CEIL} ) ) {
					$ERR = "Rate ($rate) is bigger then the ceil ($htb->{$name}{CEIL})." ;
				} else {
					$htb->{$name}{rate} = $rate ;
				}
			} else { delete $htb->{$name}{rate} ; }

			if ( $comm ne "" ) { $htb->{$name}{comm} = $comm  ;
			} else { delete $htb->{$name}{comm} ; }

			# Check the prio parameter
			if ( $prio ne "" ) {
				$prio =~ s/([01234567])//
					and $htb->{$name}{prio}  = $1
					or $ERR = "Prio must be a number between 0 and 7" ;
			} else { delete $htb->{$name}{prio} ; }

			# If we have to add a qdisc to the class, define it
			if ( $qdisc ne "" ) { $htb->{$name}{qdisc}  = $qdisc  ;
			} else { delete $htb->{$name}{qdisc} ; }

			# If child is not registered, register it
			undef $NOK ;
			foreach $ele (@{$htb->{$parent}{childs}}) {
				if ( $ele eq $name ) { $NOK = YES ;  }
			}
			push @{$htb->{$parent}{childs}}, $name if ! defined $NOK ;

			write_config2 () ; # write config
			}
		} else {
			$ERR = "Error in name : $name\n" ;
		}
	}

# adding a class
} elsif ( $submit eq "add" ) {
	print header () ;
	print start_html (-title=>"QOS configrator",-style=>{'code'=>"$CSS"}) ;
	$submit = "submit" ; # To show a submit button when we show the class info
	$action = "add_new_class" ;

	# TODO extra check needed so no error is made
	$parent = $device if ! defined $parent ; # For the first class on a device, we have no parent, so parent = device

	read_config1 () ;
	read_config2 () ;

	# Rebuild the sum of the rates of childs
	# But I don't remember me why I did it here ......
	foreach $ele (@{$htb->{$parent}{childs}}) {
		$CHILDS_RATE += $htb->{$ele}{RATE} ;
	}
	show_class ($name) ;
	docum_org () ;
	print end_html () ;
	exit ;

# editing a class
} elsif ( $submit eq "edit" ) {
	print header () ;
	print start_html (-title=>"QOS configrator",-style=>{'code'=>"$CSS"}) ;
	$submit = "submit" ; # To show a submit button when we show the class info

	read_config1 () ;
	read_config2 () ;
	# We have already the parent
	$parent = $htb->{$name}{parent} ;
	show_class ($name) ;
	docum_org () ;
	print end_html () ;
	exit ;

}

print header () ;
print start_html (-title=>"QOS configrator",-style=>{'code'=>"$CSS"}) ;
print "<h1>Error</h1>\n" if defined $ERR ;
print $ERR if defined $ERR ;

read_config1 () ;
read_config2 () ;

if ( $show eq "saved" ) {
	print "<h1>HTB tree configuration</h1>" ;
	foreach $dev (keys(%{$main->{NIC}})) {
		next if $main->{NIC}{$dev} =~ /off/ ;
		find_childs ($dev) ; # Find all childs and update all_childs
		$htb->{$dev}{RATE} = $main->{$dev}{rate} ;
		find_rates ($dev) ; # Calculates all RATE parameters
		process_device_saved  ($dev) ; # Print the configuration
	}
	write_config2 () ; # write config
	write_config2_debug () if defined $DEBUG ;

} elsif ( $show eq "running" ) {
	print "<h1>HTB tree running configuration</h1>" ;
	foreach $dev (keys(%{$main->{NIC}})) {
		next if $main->{NIC}{$dev} =~ /off/ ;
		read_config_tc_tree ("$dev") ;
		$i = 0 ;
		$k = 0 ;
		$row_max = 0 ;
		@table = 0 ;
		$table = "" ;
		@col   = 0 ;
		process_running (root) ;
		$row_max ++ ;
	
		print "<h3>Interface : $dev</h3>" ;
		print "<p>\n<table celpadding=0 cellspacing=0 border=1>\n";
		print "\n\n\n\n<p>\n<table celpadding=0 cellspacing=0 border=1>\n<tr>";
		print "<th width=20 colspan=$row_max>Device $dev </th>"  ;
		print "<th>rate</th>\n" ;
		print "<th>ceil</th>\n" ;
		print "<th>prio</th>\n" ;
		print "<th>leaf</th>\n" ;
		print "</tr>";
		print_table () ;
	}
	
	print "<p>\n" ;
	print startform () ;
	print submit (-name=>'submit',-value=>"refresh") ;
	print hidden (-name=>"show",
			-override=>1,
			-value=>$show) ;
	print endform () ;

} elsif ( $show eq "commit" ) {
	create_script () ;
	if ( $password eq "planet" ) { 
		print "<h1>Refreshed</h1>\n\n" ;
		#$test = `$CONFIG/tc.sh 2>&1` ;
		$test = `cat $CONFIG/tc.sh 2>&1` ;
		print "<pre>$test</pre>\n" ;
	} else {
		print "<h1>Sorry</h1>\n" ;
		print "This really works, but this is just a demo, so you can't apply the configuration.  Except if you know the password :).\n" ;
		$test = `cat $CONFIG/tc.sh 2>&1` ;
		print "<pre>$test</pre>\n" ;
	}

	print "<h1>Applying HTB / filter configuration</h1>\n" ;
	print startform () ;
	print submit (-name=>'submit',-value=>"commit") ;
	print "<br>password : " ;
	print password_field (-name => 'password');
	print hidden (-name=>"show",
			-override=>1,
			-value=>$show) ;
	print endform () ;

}
docum_org () ;
print end_html () ;

sub process_running {
	$class = $_[0] ; 
	local @temp = split " ", $tree->{$class}{childs} ;
	foreach $ele (@temp) {
		$i ++ ; # Number of column
		$k ++ ; # Number of row
		$row_max = $i if ( $row_max < $i ) ; # Remember the number of columns
		$col[$i] ++ ; # Remember how many rows we have in a column

		# building lit of childs
		if ( defined $childs{$parent[($i-1)]} ) { $childs{$parent[($i-1)]} = $childs{$parent[($i-1)]} . "_" . $ele ;
		} else { $childs{$parent[($i-1)]} = $ele ; }

		$number_of_row[$k] = $i ;
		$table[$k] .= "<td colspan=COLSPAN class=left>" ;
		# later on, we replace CHILDS with list of childs
		$table[$k] .= "<a href=$CGI_BASE/tcrrd.pl?handle=$ele&int=$dev&childs=CHILDS>$ele</a>" ;
		$parent[$i] = $ele ;

		$temp = $dev . ":" . ( split (":",$ele)) [1] ;
		$table[$k] .= " ($htb->{$temp}{comm})\n" if $htb->{$temp}{comm} ;

		$table[$k] .= "</td>\n" ;
		$table[$k] .= "<td>$tree->{$ele}{rate} kbps</td>\n" ;
		$table[$k] .= "<td>$tree->{$ele}{ceil} kbps</td>\n" ;
		if ( $tree->{$ele}{prio} ) {
			$table[$k] .= "<td>$tree->{$ele}{prio}</td>\n" ;
		} else {
			$table[$k] .= "<td>&nbsp;</td>\n" ;
		}

		if ( $tree->{$ele}{leaf} ne "" ) {
			$type = $tree->{$tree->{$ele}{leaf}}{type} ;
			$table[$k] .= "<td>$type</td>\n" ;
		} else {
			$table[$k] .= "<td>&nbsp;</td>\n" ;
		}

		process_running ($ele) ;
		$i -- ;
	}
}

sub show_class {
	$name = $_[0] ;
	print startform () ;
	print hidden (-name=>"action",
				-override=>1,
				-value=>$action) ;

	print "<table border=1>\n" ;

	$class = $name ;
	$name = (split ":", $name)[-1] ;
	print "<tr><th>Name</td><td class=left>\n" ;
	if ( $name ne "" ) { print "$name" ;
		print hidden (-name=>"name",
	                      -override=>1,
		              -value=>$name) ;
	} else { print textfield (-name=>"name",
	                        -override=>1,
	                 	-value=>$name) ;
	}

	local @temp = split (":",$parent) ;
	print "</td></tr>\n<tr><th>Parent</td><td class=left>\n" ;
	#if ( $parent ne "" ) {
		print "$temp[-1]" ;
		print hidden (-name=>"parent",
				-override=>1,
				-value=>$temp[-1]) ;
		      #} else { print textfield (-name=>"parent",
		      #-override=>1,
		      #-value=>$htb->{$class}{parent} ) ;
		      #}

	print "</td></tr>\n<tr><th>Device</td><td class=left>\n" ;
	#if ( $parent ne "" ) {
		print "$temp[0]" ;
		print hidden (-name=>"device",
		              -value=>$temp[0]) ;
		#print hidden (-name=>"parent",
		#-value=>$parent) ;
		#} else { print textfield (-name=>"parent",
		#-override=>1,
		#-value=>$htb->{$class}{parent} ) ;
		#}

	print "</td></tr>\n<tr><th>Comment</td><td class=left>\n" ;
	if ( $comm ne "" ) { print "$comm" ;
		print hidden (-name=>"comm",
		              -value=>$comm) ;
	} else { print textfield (-name=>"comm",
	                 	 -override=>1,
                         	 -value=>$htb->{$class}{comm} ) ;
	}

	print "</td></tr>\n<tr><th>Rate</td><td class=left>\n" ;
	if ( $rate ne "" ) {
		if ( $rate =~ /%|kbps|nbsp/ ) { print "$rate" ;
		} else { print "$rate kbps" ; }
	} else {
		if ( ( $htb->{$class}{rate} =~ /%/ ) or ( $htb->{$class}{rate} eq "" ) ) {
			print textfield (-name=>"rate",
	                  	 	-override=>1,
	                 	 	-value=>$htb->{$class}{rate},
                 	 	 	-size=>"10" ) ;
		} else {
			print textfield (-name=>"rate",
	                  	 	-override=>1,
	                 	 	-value=>"$htb->{$class}{rate} kbps",
                 	 	 	-size=>"10" ) ;
		}
		print " (" . help ("rate") . ") " ;
	}

	print "</td></tr>\n<tr><th>Ceil</td><td class=left>\n" ;
	if ( $ceil ne "" ) {
		if ( $ceil =~ /%|kbps|LINK|nbsp/ ) { print "$ceil" ;
		} else { print "$ceil kbps" ; }
	} else { 
		if ( ( $htb->{$class}{ceil} =~ /%/ ) or ( $htb->{$class}{ceil} =~ /LINK/ ) or ( $htb->{$class}{ceil} eq "" ) ) {
			print textfield (-name=>"ceil",
	                  	 	-override=>1,
	                 	 	-value=>$htb->{$class}{ceil},
                 	 	 	-size=>"10" ) ;
		} else {
			print textfield (-name=>"ceil",
	                  	 	-override=>1,
	                 	 	-value=>"$htb->{$class}{ceil} kbps",
                 	 	 	-size=>"10" ) ;
		}
		print " (" . help ("ceil") . ") " ;
	}

	print "</td></tr>\n<tr><th>Prio</td><td class=left>\n" ;
	if ( $prio ne "" ) { print "$prio" ;
	} else { print textfield (-name=>"prio",
	                 	-value=>$htb->{$class}{prio},
                 	 	-size=>"2" ) ;
	}

	print "</td></tr>\n<tr><th>Qdisc</td><td class=left>\n" ;
	if ( $qdisc ne "" ) { print "$qdisc" ;
	} else { print popup_menu (-name=>"qdisc",
			-values=>["sfq","none"],
			-default=>"$htb->{$class}{qdisc}") ;
	}

	print "</td></tr>\n<tr><th colspan=2>" ;
	print submit (-name=>'submit',-value=>"$submit") ;
	print "</th></tr>\n ";

	print "</table>\n" ;

	print hidden (-name=>"show",
			-override=>1,
			-value=>"saved") ;
	print endform () ;
}

# Deleting a class means also deleting all child classes
sub delete_class {
	$class = $_[0] ;
	local @childs = @{$htb->{$class}{childs}} ;
	delete $htb->{$class} ;
	foreach (@childs) {
		delete_class ($_);
	}
}
