#!/usr/bin/perl

# 0.2
#   05/05/2003
#   you don't have to enter a rate/qdisc if you disable a nic
# 0.1
#   19/02/2003
#
# # # #   What
#
# Enabling a device
# Configuring the outgoing bandwidth
# Determining the major number 
#
# # # #   Remark
#
# - For the checkbox, bandwidth and qdisc, I use parameters with the 
#   device name in it.  Example : RATEeth0.
#   So I can use 1 form for all input
# - I use the output of ip to get the information about the configured devices
#
# # # # # #  # # #

BEGIN { push (@INC,'/qos/modules'); }

use CGI qw (:standard) ;
use Data::Dumper ;
use qos_config ;
use qos ;

$cgi = url () ;
# $DEBUG = yes ;

$submit  = param('submit') ;

# Find more info about a nic
sub nic_info {
	my @info = `ip addr show $_[0]` ; # A normal user can run ip to get information about the running configuration
	if ( $info[0] =~ "does not exists" ) {
		return ("NIC not Configured") ;
	} elsif ( $info[2] =~ "inet " ) {
		my @info = split ( " ", $info[2] );
		return $info[1] ;
	} else {
		return ("NIC not Configured") ; }
}

if ( $submit eq "submit" ) {
	read_config1 () ;

	# ??????????????
	foreach $key (keys(%{$main->{NIC}})) {
		if ( param ("NIC$key") ) { $main->{NIC}{$key} = "on" ;
		} else {                   $main->{NIC}{$key} = "off" ; }
	}

	foreach $param (param) {
		# If the box is checked, enable the NIC
		if ( $param =~ /NIC/ ) {
			$param =~ s/NIC//g ;
			$main->{NIC}{$param} = "on" ;
		# If we have a rate ...
		} elsif ( $param =~ /RATE/ ) {
			$param =~ s/RATE//g ;
			$main->{$param}{rate} = check_speed (param ("RATE$param")) ;
			if ( ( ! $main->{$param}{rate} ) && ( $main->{NIC}{$param} eq "on" ) ) {
				$ERR = "Wrong bandwidth parameter\n" ;
			}
		# If we have a qdisc number ...
		} elsif ( $param =~ /QDISC/ ) {
			$param =~ s/QDISC//g ;
			my $temp = param ("QDISC$param") ;
			$temp =~ s/^0*//g ;
			if ( $temp =~ /^[1234567890abcdef]{1,4}$/ ) {
				$main->{$param}{qdisc} = $temp ;
			} else {
				if ( $main->{NIC}{$param} eq "on" ) {
					$ERR = "Error in root qdisc number.\n" ;
				}
			}
		}
	}
	write_config1 () if !$ERR ;
}

print header () ;
print start_html (-title=>"QOS configrator",-style=>{'code'=>"$CSS"}) ;
read_config1 () ;

# If we had an error, show it to the user
print "<h1>Error</h1>\n" if defined $ERR ;
print $ERR if defined $ERR ;


# Get a list of configured nics
%nic = nics () ;

print startform ( -action=>$cgi) ;
print "<h1>Netwerk card configuration</h1>\n" ;

print "<p>\n<table width=100% border=1>\n";
print "<tr><th>nr</th><th colspan=2>NIC</th><th>ip-address / netmask</th><th>outgoing bandwidth (" . help ("bandwidth") . ")</th>\n" ;
print "<th>root qdisc number (" . help ("major-number") . ")</th></tr>\n" ;

# Show the NIC information
foreach $key (keys(%nic)) {
	$a = nic_info ($nic{$key}) ;
	print "<tr><th>$key</th>\n" ;
	if ( $nic{$key} =~ /lo/ ) {
		print "<td colspan=2>$nic{$key}</td><td>" ;
	} else {
		print "<td>$nic{$key}</td><td>" ;
		if ( $main->{NIC}{$nic{$key}} =~ /on/ ) {
			print checkbox (-name=>"NIC$nic{$key}",
				-checked=>'checked',
				-value=>"NIC$nic{$key}",
				-label=>'Use') ;
		} else {
			print checkbox (-name=>"NIC$nic{$key}",
				-value=>"NIC$nic{$key}",
				-label=>'Use') ;
		}
		print "</td>\n<td>" ;
	}
	print "$a</th>\n<td>" ;
	if ( $nic{$key} =~ /lo/ ) {
		print "&nbsp;" ;
	} else {
		if ( $main->{$nic{$key}}{rate} ) {
			print textfield (-name=>"RATE$nic{$key}",
				-default=>"$main->{$nic{$key}}{rate} kbps",
				-override=>"1",
				-size=>8) ;
		} else {
			print textfield (-name=>"RATE$nic{$key}",
				-default=>"$main->{$nic{$key}}{rate}",
				-override=>"1",
				-size=>8) ;
		}
	}
	print "</th>\n<td>" ;
	if ( $nic{$key} =~ /lo/ ) {
		print "&nbsp;" ;
	} else {
		print textfield (-name=>"QDISC$nic{$key}",
			-default=>"$main->{$nic{$key}}{qdisc}",
			-override=>"1",
			-size=>4) ;
	}
	print "</td>\n</tr>\n" ;
}

print "</table>";
print submit (-name=>'submit',-value=>"submit") ;
print endform ();

print "<p>todo : add an example with a ASCII dawing and 2 NIC's" ;
print "<p>You can only manage the outgoing bandwidth. Use this page to configure the network bottleneck that existst on the network card.  Most of the time this is a router/modem to you ISP.  It's possible that you have to outgoing bandwidth a little lower then the actually bandwidth before you will notice the difference." ;
print "<br>Example : If you have eth0 connected to your LAN and your link to you ISP has a download limit of 768 kbit, you have to configure eth0 so it the Outgoing bandwidth is 768 kbit." ;
print "<p>You can also enable the network cards you want to configure.\n" ;

docum_org () ;

write_config1_debug () if defined $DEBUG ;
print end_html () ;
