#!/usr/bin/perl

# Process all the configured classes and calculate the real rate
sub find_rates {
	$class = $_[0] ;
	foreach $ele (@{$htb->{$class}{childs}}) {
		$parent_rate = $htb->{$htb->{$ele}{parent}}{RATE} ;
		undef ( @unknown ) ; # List of classes with no configured rate
		foreach $ele (@{$htb->{$class}{childs}}) {
			if ( $htb->{$ele}{rate} ) {
				if ( $htb->{$ele}{rate} =~ /\%/ ) {
					if ( $htb->{$htb->{$ele}{parent}}{RATE}) {
						$htb->{$ele}{RATE} = $htb->{$htb->{$ele}{parent}}{RATE} * $htb->{$ele}{rate} / 100 ;
						$parent_rate = $parent_rate - $htb->{$ele}{RATE} ;
					} else {
						$htb->{$ele}{RATE} = $main->{$qdisc}{rate} * $htb->{$ele}{rate} / 100 ;
						$parent_rate = $parent_rate - $htb->{$ele}{RATE} ;
					}
				} else {
					$htb->{$ele}{RATE} = $htb->{$ele}{rate} ;
					$parent_rate = $parent_rate - $htb->{$ele}{RATE} ;
				}
			} else { # Remember the classes with no configured rate
				if ( $htb->{$ele}{parent} ) {
					push ( @unknown, $ele ) ; # List of class with no configured rate
				} else {
					$htb->{$ele}{RATE} = $main->{$qdisc}{rate} ;}
			}
		}

		my $temp = $#unknown + 1 ;
		# Give the not-configured classes the remaining parent rate
		foreach $ele (@unknown) {
			$htb->{$ele}{RATE} = int ($parent_rate / $temp) ;
		}
		find_rates ($ele) ;
	}
}

# Create a list from the saved configuration
sub process_device_saved {
	local $qdisc = $_ [0] ; # We need a starting point ...
	local @table ;

	$row_max = 0 ; # Maximum of class so we know how big the header must be
	#$#table = "0" ;
	$k = 0 ;
	$i = 0 ;
	$row_max = 0 ;
	@table = 0 ;
	$table = "" ;
	@col   = 0 ;

	# Process all information and create an array with table lines
	process_saved ($qdisc) ;

	$row_max ++ ;

	# Creating a header
	$header = "\n\n\n\n<p>\n<table border=1 cellpadding=0 cellspacing=1>\n<tr>";
	$header .= "<th width=20 colspan=$row_max>Name</th>"  ;
	$header .= "<th colspan=3>rate" ;
	$header .= "(" . help (rate) . ")" if ! defined $overview ;
	$header .= "</th>\n" ;
	$header .= "<th colspan=2>ceil" ;
	$header .= "(" . help (ceil) . ")" if ! defined $overview ;
	$header .= "</th>\n" ;
	$header .= "<th>prio" ;
	$header .= "(" . help (prio) . ")" if ! defined $overview ;
	$header .= "</th>\n" ;
	$header .= "<th>remarks</th>\n" ;
	if ( ! defined $overview ) {
		$header .= "<th>qdisc (" . help ("qdisc") . ")</th>\n" ;
		$header .= "<th colspan=3>Actions</th>\n" ;
		$header .= "</tr>";

		$header .= "<tr><th colspan=$row_max>Out on $qdisc</th>\n" ;
		$header .= "<td>Configured</td>\n" ;
		$header .= "<td colspan=2>Calculated</td>\n" ;
		$header .= "<td>Configured</td>\n" ;
		$header .= "<td>Calculated</td>\n" ;
		$header .= "<td colspan=3>Link bandwidth : $main->{$qdisc}{rate} kbps</td>\n" ;
		$header .= "<td>";
		$header .= startform () ;
		$header .= submit (-name=>'submit',-value=>"add") ;
		$header .= hidden (-name=>'device',-value=>$qdisc) ;
		$header .= endform () ;
		$header .= "</td>\n" ;
		$header .= "<td colspan=2>\n" ;
		$header .= startform () ;
		@values = sort (@{$htb->{$qdisc}{all_leaf_childs}} ) ;
		push @values,"NONE" ;
		$header .= popup_menu (-name=>"default",
				-size=>1,
				-override=>1,
				-default=>$main->{$qdisc}{default},
				-values=>[@values]);
		$header .= submit (-name=>'submit',-value=>"default") ;
		$header .= hidden (-name=>'device',-value=>$qdisc) ;
		$header .= hidden (-name=>'show',-value=>$show) ;
		$header .= endform () ;
		$header .= "</td>\n" ;
	}
	$header .= "</tr>\n" ;

	print "$header" ;
	print_table () ;
}

sub print_table {
	# Processing the lines we found
	foreach $k (1..$#table) {
		# Get our "row"
		$row = $number_of_row[$k] ;

		# Colspan of class name cell = maximum of rows - row
		$temp = $row_max - $row ;
		$table[$k] =~ s/COLSPAN/$temp/ ;

		# replace CHILDS with a the real list of childs
		$table[$k] =~ /CHILDS>(.+)<\/a>/ ;
		$class = $1 ;
		$table[$k] =~ s/CHILDS/$childs{$class}/g ;

		# $childs{$parent[($i-1)]} = $ele ; 

		# How many lines left who start in the same column ?
		$col[$row] -- ;

		# Find the image we need ...
		$line = "" ;
		for $i (2..$row) {
			$temp = $i -1 ;
			if ( $col[$temp] != "0" ) { # Is there a row below this row that start in the same column ?
				$line .= "<td width=20 border=0 height=20 class=png><img src=$WWW_BASE/images/VBAR20.png></td>" ;
			} else {
				$line .= "<td width=20 border=0 height=20 class=png><img src=$WWW_BASE/images/BLANC.png></td>" ;
			}
		}
		if ( $col[$row] != "0" ) { # Is there a row below this row that start in the same column ?
			$line .= "<td width=20 border=0 height=20 class=png><img src=$WWW_BASE/images/TBAR20.png></td>" ;
		} else {
			$line .= "<td width=20 border=0 height=20 class=png><img src=$WWW_BASE/images/LBAR20.png></td>" ;
		}

		$table[$k] = "<tr>" . $line . $table[$k] . "</tr>" ;

		$table .= $table[$k] ;
	}
	$table .= "</table>";
	print "$table" ;
}

sub process_saved {
	$class = $_[0] ; 
	foreach $ele (sort(@{$htb->{$class}{childs}}) ) {
		$k ++ ;
		$i ++ ;
		$row_max = $i if ( $row_max < $i ) ;
		$col[$i] ++ ;
		$number_of_row[$k] = $i ;
		$table[$k] .= "<td colspan=COLSPAN class=left>" ;
		$table[$k] .= (split (":",$ele))[-1] ;
		$table[$k] .= " ($htb->{$ele}{comm})" if $htb->{$ele}{comm} ;
		$table[$k] .= "</td>\n" ;

		my $WAR ;
		if ( $htb->{$ele}{RATE} < 0 ) {
			$WAR = "Rate is < 0" ;
		}

		# Print configured rate
		if ( $htb->{$ele}{rate} =~ /%/ ) {
			$table[$k] .= "<td>$htb->{$ele}{rate}</td>" ;
		} elsif ( $htb->{$ele}{rate} ) {
			$table[$k] .= "<td>$htb->{$ele}{rate} kbps</td>" ;
		} else {
			$table[$k] .= "<td>&nbsp;</td>" ;
		}

		# Print used rate
		# print "ele $ele X $htb->{$ele}{RATE} A $htb->{$htb->{$ele}{parent}}{RATE} B $htb->{$ele}{parent} <br>" ;
		#if ( defined ( $htb->{$htb->{$ele}{parent}}{RATE} ) ) {
		  my $PRCT = int ( $htb->{$ele}{RATE} / $htb->{$htb->{$ele}{parent}}{RATE} * 1000 ) / 10 ;
		#} else {
		  #my $PRCT = "0" ;
		#}
		$table[$k] .= "<td>$htb->{$ele}{RATE} kbps</td><td>$PRCT%</td>\n" ;

		# Print configured ceil
		if ( $htb->{$ele}{ceil} eq "LINK" ) {
			$table[$k] .= "<td>$htb->{$ele}{ceil}</td>\n" ;
		} elsif ( defined $htb->{$ele}{ceil} ) {
			$table[$k] .= "<td>$htb->{$ele}{ceil} kbps</td>\n" ;
		} else {
			$table[$k] .= "<td>&nbsp;</td>\n" ;
		}

		# Find used ceil
		my $TEMP ;
		if ( $htb->{$ele}{ceil} eq "LINK" ) {
			if ( $htb->{$htb->{$ele}{parent}}{CEIL} ) {
				$CEIL = $htb->{$htb->{$ele}{parent}}{CEIL} ;
				$TEMP = "PCeil" ;
			} else {
				$CEIL = $main->{$qdisc}{rate} ;
				$TEMP = "Link" ;
			}
		} elsif ( $htb->{$ele}{ceil} ) {
			$CEIL = $htb->{$ele}{ceil} ;
		} elsif ( $htb->{$ele}{RATE} ) {
			$CEIL = $htb->{$ele}{RATE} ;
			$TEMP = "Rate" ;
		} elsif ( $htb->{$htb->{$ele}{parent}}{CEIL} ) {
			$CEIL = $htb->{$htb->{$ele}{parent}}{CEIL} ;
			$TEMP = "PCeil" ;
		} else {
			$CEIL = $main->{$qdisc}{rate} ;
			$TEMP = "Link" ;
		}

		if ( $TEMP ) {
			$table[$k] .= "<td>$CEIL kbps ($TEMP)</td>\n" ;
		} else {
			if ( $TEMP ) {
				$table[$k] .= "<td>$TEMP</td>\n" ;
			} else {
				$table[$k] .= "<td>&nbsp;</td>\n" ;
			}
		}
		$htb->{$ele}{CEIL} = $CEIL ;

		# Print prio
		if ( $htb->{$ele}{prio} ) { $table[$k] .= "<td>$htb->{$ele}{prio}</td>\n" ;
		} else {                    $table[$k] .= "<td>&nbsp;</td>\n" ; }

		# Print warning
		if ( $WAR ) {
			$table[$k] .= "<td>$WAR</td>\n" ;
		} else {
			$table[$k] .= "<td>&nbsp;</td>\n" ;
		}

		if ( ! $overview ) {
			if ( @{$htb->{$ele}{childs}} != "" ) {
				$table[$k] .= "<td>N/A</td>\n" ;
			} elsif ( $htb->{$ele}{qdisc} and ( $htb->{$ele}{qdisc} ne "none" ) ) {
				$table[$k] .= "<td>$htb->{$ele}{qdisc}</td>\n" ;
			} else {
				$table[$k] .= "<td>&nbsp;</td>\n" ;
			}

			$table[$k] .= "<td>";
			$table[$k] .= startform () ;
			$table[$k] .= submit (-name=>'submit',-value=>"add") ;
			$table[$k] .= hidden (-name=>'parent',-override=>"1",-value=>$ele) ;
			$table[$k] .= endform () ;
			$table[$k] .= "</td>\n" ;

			$table[$k] .= "<td>";
			$table[$k] .= startform () ;
			$table[$k] .= submit (-name=>'submit',-value=>"edit") ;
			$table[$k] .= hidden (-name=>'name',-override=>"1",-value=>"$ele") ;
			$table[$k] .= endform () ;
			$table[$k] .= "</td>\n" ;

			$table[$k] .= "<td>";
			$table[$k] .= startform () ;
			$table[$k] .= submit (-name=>'submit',-value=>"delete") ;
			$table[$k] .= hidden (-name=>'name',-override=>"1",-value=>$ele) ;
			$table[$k] .= endform () ;
			$table[$k] .= "</td>\n" ;
		}
		$table[$k] .= "</tr>\n";
		process_saved ($ele) ;
		$i -- ;
	}
}

return 1 ;
