#!/usr/bin/perl

sub read_config_tc_tree {
	undef $VAR1 ;
	my $nic = $_[0] ;
	open (FILE, "$CONFIG/tc.$nic") or die ;
	@file = <FILE> ;
	close FILE ;
	eval ("@file") ;
	die "Failed to eval $@\n" if $@ ;
	$tree = eval (Dumper ($VAR1)) ;
}

sub read_config1 {
	undef $VAR1 ;
	open (FILE, "$CONFIG/main") ;
	@file = <FILE> ;
	close FILE ;
	eval ("@file") ;
	die "Failed to eval $@\n" if $@ ;
	$main = eval (Dumper ($VAR1)) ;
}

sub read_config2 {
	undef $VAR1 ;
	open (FILE, "$CONFIG/htb") ;
	@file = <FILE> ;
	close FILE ;
	eval ("@file") ;
	die "Failed to eval $@\n" if $@ ;
	$htb = eval (Dumper ($VAR1)) ;
}

sub read_config3 {
	undef $VAR1 ;
	open (FILE, "$CONFIG/filter") ;
	@file = <FILE> ;
	close FILE ;
	eval ("@file") ;
	die "Failed to eval $@\n" if $@ ;
	$filter = eval (Dumper ($VAR1)) ;
}

sub read_config4 {
	open (FILE, "$CONFIG/u32") ;
	@file = <FILE> ;
	close FILE ;
	eval ("@file") ;
	die "Failed to eval $@\n" if $@ ;
	$u32 = eval (Dumper ($VAR1)) ;
}

sub write_config1 {
	open (FILE, ">$CONFIG/main" ) || die "Can not open file $CONFIG/main\n" ;
	print FILE Dumper ($main) ;
	close FILE ;
}

sub write_config2 {
	open (FILE, ">$CONFIG/htb" ) || die "Can not open file $CONFIG/htb\n" ;
	print FILE Dumper ($htb) ;
	close FILE ;
}

sub write_config3 {
	open (FILE, ">$CONFIG/filter" ) || die "Can not open file $CONFIG/filter\n" ;
	print FILE Dumper ($filter) ;
	close FILE ;
}

sub write_config4 {
	open (FILE, ">$CONFIG/u32" ) || die "Can not open file $CONFIG/u32\n" ;
	print FILE Dumper ($u32) ;
	close FILE ;
}

sub write_config1_debug { print "<h1>Debug information</h1>\n<pre>";print Dumper($main) ; print "</pre>\n" }
sub write_config2_debug { print "<h1>Debug information</h1>\n<pre>";print Dumper($htb) ; print "</pre>\n" }
sub write_config3_debug { print "<h1>Debug information</h1>\n<pre>";print Dumper($filter) ; print "</pre>\n" }
sub write_config4_debug { print "<h1>Debug information</h1>\n<pre>";print Dumper($u32) ; print "</pre>\n" }

# Check the rate the user entered.  
# It can be the real rate or in %
sub check_rate {
	if ( $_[0] =~ /\%/ ) {
		$ret = check_prct ($_[0]) ;
	} else {
		$ret = check_speed ($_[0]) ;
	}
	return $ret ;
}

# Check if the user entered something usefull
sub check_prct {
	if ( $_[0] =~ /\%/ ) {
		local $temp = $_[0] ;
		$temp =~ /([0-9.]+)[ ]*(%)/i ;
		my $num = $1 ;
		if ( ( $num > 100 ) or ( $num < 0 ) ) {
			return undef ;
		} else {
			return "$num %" ;
		}
	} else{
		return undef ;
	}
}

# Check the speed the user enter.
# And calculate the value in kbps
sub check_speed {
	if ( $_[0] =~ /^[0-9]+$/ ) {
		$_[0] = $_[0] . " kbps" ;
	}
	if ( $_[0] =~ /([0-9.]+[ ]*kbps|[0-9.]+[ ]*mbps)/i ) {
		local $temp = $1 ;
		$temp =~ /([0-9.]+)[ ]*(kbps|mbps)/i ;
		my $num = $1 ;
		my $type = $2 ;
		if ( $type =~ /m/i ) {
			$num = $num * 1024 ;
		}

		return "$num" ;
	}
	if ( $_[0] =~ /([0-9.]+[ ]*kbit|[0-9.]+[ ]*mbit)/i ) {
		local $temp = $1 ;
		$temp =~ /([0-9.]+)[ ]*(kbit|mbit)/i ;
		my $num = $1 ;
		my $type = $2 ;
		$num = $1 / 8 ;
		if ( $type =~ /m/i ) {
			$num = $num * 1024 ;
		}
		return "$num" ;
	}
	if ( $_[0] =~ /([0-9.]+[ ]*bps)/i ) {
		local $temp = $1 ;
		$temp =~ /([0-9.]+)[ ]*(bps)/i ;
		my $num = $1 ;
		my $type = $2 ;
		$num = $num/1024/1024 ;
		return "$num" ;
	}
	return undef ;
}

# Create the tc script
sub create_script {
	read_config1 () ;
	read_config2 () ;
	read_config3 () ;
	read_config4 () ;
	open (FILE, ">$CONFIG/tc.sh" ) ;
	chmod (0755,"$CONFIG/tc.sh") ;
	print FILE "set -v\n" ;

	foreach $dev (keys(%{$main->{NIC}})) {
		next if $main->{NIC}{$dev} =~ /off/ ;
		print FILE "$TC qdisc del dev $dev root\n" ;
		$qdisc = $main->{$dev}{qdisc} ;
		print FILE "$TC qdisc add dev $dev root handle $qdisc: htb " ;
		if ( $main->{$dev}{default} !~ "NONE" ) {
			@split = split ":", $main->{$dev}{default} ;
			print FILE "default $split[1]\n" ;
		} else {
			print FILE "\n" ;
		}

		create_script_class ($dev) ;
		create_script_filter ($dev) ;
	}
	close FILE ;
}

# Create the filter rules
sub create_script_filter {
	$class = $_[0] ;
	if ( defined $filter->{$class} ) {
		foreach my $name (keys(%{$filter->{$class}})) {
			$filter->{$class}{$name}{dest} = ( split (":", $filter->{$class}{$name}{dest} ) ) [1] ;
			if ( defined $filter->{$class}{$name}{prio} ) { $PRIO = "prio $filter->{$class}{$name}{prio} ";
			} else { $PRIO = "" ; }
			$QDISC = $main->{$class}{qdisc} . ":" ;
			print FILE "\n# Filter name : $name\n" ;
			if ( $filter->{$class}{$name}{type} eq "fw" ) {
				print FILE "#     type : fw\n" ;
				@MARKS = find_numbers ($filter->{$class}{$name}{mark}) ;
				foreach $mark (@MARKS) {
					print FILE "$TC filter add dev $dev parent $QDISC protocol ip $PRIO handle $mark fw classid  $QDISC$filter->{$class}{$name}{dest} \n" ;
				}
			} elsif ( $filter->{$class}{$name}{type} eq "u32" ) {
				my $rule = $filter->{$class}{$name}{rule} ;
				my @dst   = find_numbers ($u32->{$rule}{dst}   ) ; push @dst  , "" ;
				my @src   = find_numbers ($u32->{$rule}{src}   ) ; push @src  , "" ;
				my @dport = find_numbers ($u32->{$rule}{dport} ) ; push @dport, "" ;
				my @sport = find_numbers ($u32->{$rule}{sport} ) ; push @sport, "" ;
				$rule = "" ;
				#print FILE "# dst $#dst @dst\n" ;
				#print FILE "# src $#dst @src\n" ;
				#print FILE "# dport  $#dport @dport\n" ;
				#print FILE "# sport  $#sport @sport\n" ;
				foreach $dst (@dst) {
				foreach $src (@src) {
				foreach $sport (@sport) {
				foreach $dport (@dport) {
					next if $dport eq "" and $#dport ne "0" ;
					next if $sport eq "" and $#sport ne "0" ;
					next if $dst   eq "" and $#dst   ne "0" ;
					next if $src   eq "" and $#src   ne "0" ;
					$rule = "" ;
					$rule .= "match ip dst $dst " if $dst ne "" ;
					$rule .= "match ip src $src " if $src ne "" ;
					$rule .= "match ip sport $sport 0xffff " if $sport ne "" ;
					$rule .= "match ip dport $dport 0xffff " if $dport ne "" ;
					print FILE "$TC filter add dev $dev parent $QDISC protocol ip u32 $rule $PRIO classid  $QDISC$filter->{$class}{$name}{dest} \n" if $rule ne "" ;
				}
				}
				}
				}
			} else {
				print FILE "# TEST \n" ;
			}
		}
	}
       	my @childs = @{$htb->{$class}{childs}} ;
	foreach $class (@childs) {
		create_script_filter ($class) ;
	}
}

# Create the class rules
sub create_script_class {
	$parent = $_[0] ;
	local @childs = @{$htb->{$parent}{childs}} ;
	foreach $ele (@childs) {
		if ( $htb->{$ele}{comm} ) {
			print FILE "# $htb->{$ele}{comm}\n" ;
		}
		print FILE "$TC class add dev $dev " ;
		$class  = (split ( ":", $ele ))[1] ;
		$parent = (split ( ":", $htb->{$ele}{parent} )) [1] ;
		# If we have a class attached to the device, there is only a major number
		#if ( $parent == $ele ) { $parent = "" ; }
		print FILE "parent $qdisc:$parent classid $qdisc:$class htb " ;

		$rate = $htb->{$ele}{RATE}   ;
		$rate =~ s/ //g ;
		print FILE "rate $rate" . "kbps ";

		$ceil = $htb->{$ele}{CEIL} ;
		$ceil =~ s/ //g ;
		print FILE "ceil $ceil" . "kbps " ;

		if ( $htb->{$ele}{prio} ) { print FILE "prio $htb->{$ele}{prio} " ; }
		print FILE "\n" ;

		if ( ( $#{$htb->{$ele}{childs}} eq "-1" )  and $htb->{$ele}{qdisc} and ( $htb->{$ele}{qdisc} ne "none" ) ) {
			print FILE "$TC qdisc add dev $dev parent $qdisc:$class $htb->{$ele}{qdisc}\n"  ; }
		create_script_class ($ele) ;
	}
}

# Small help function to draw a help-link
sub help {
	$ret = "<a href=# onClick=MyWindow=window.open('help.pl?submit=$_[0]','MyWindow','toolbar=yes,location=yes,directories=yes,status=yes,menubar=yes,scrollbars=yes,resizable=yes,width=300,height=500'); return false;>?</a>" ;
	return $ret ;
}

# walk thru all the child classes
sub find_childs {
	$class = $_[0] ;
	undef $htb->{$class}{all_childs} ;
	undef $htb->{$class}{all_leaf_childs} ;
	childs ($class) ; # Find all the childs for this class
	my @childs = @{$htb->{$class}{childs}} ;
	foreach $class (@childs) {
		find_childs ($class) ;
	}
}

# Update all_childs for this class
sub childs {
	my @childs = @{$htb->{$_[0]}{childs}} ;
	if ( $#childs eq "-1" ) {
		push (@{$htb->{$class}{all_leaf_childs}}, $_[0]) ;
	}

	foreach $child (@childs) {
		push (@{$htb->{$class}{all_childs}}, $child) ;
		childs ($child) ;
	}
}

# Find all configured nics
sub nics {
	my %nic ;
	foreach (`ip link show`) {
		$_ =~ /^([0-9]+):[ ]+([a-z0-9]+)/ or next ;
		$nic{$1} = $2 ;
	}
	return %nic ;
}

sub docum_org {
	if ( ! $DISABLE_DOCUM ) {
		print "\n<div align=right>\n" ;
		print "Developed by Stef Coene <a href=\"http://www.docum.org\" target=_new>www.docum.org</a>\n" ;
		print "</div>\n" ;
	}
}

# walk thru all the child classes
sub find_filters {
	my $parent = $_[0] ;
	$/ = "filter" ;
	@filter = `$TC filter show $DEV parent $parent` ;
	$/ = "\n" ;

	foreach $filter (@filter) {
		my @split = split " ", $filter ;
		if ( $split[4] eq "fw" ) {
			if ( $#split == "5" ) { next ; }
			my $key = $parent . " " . $split[8] ;
			shift (@split) ;
			$#split -- ; $#split -- ;
			if ( $split[5] eq "0x1" ) {
 				$color{$key} = "yellow" . "\;" . $color{$key} ;
			} elsif ( $split[5] eq "0x2" ) {
				$color{$key} = "green" . "\;" . $color{$key} ;
			} else {
				$color{$key} = "blue" . "\;" . $color{$key} ;
			}
	
			$filter{$key} = $split[5]."\;".$filter{$key};
			$type{$key} = "fw" ;
		} elsif ( $split[4] eq "u32" ) {
			if ( $#split < "11" ) { next ; }
			my $key = $parent . " " . $split[15] ;
			$filter{$key} = $split[6] . "\;" . $filter{$key};
			@split = split "\n", $filter ;
			shift (@split) ;
			$option{$key} = join ("\n", @split) ;
			$option{$key} =~ s/\nfilter// ;
			$color{$key} = "black" ;
			$type{$key} = "u32" ;
		}
	}
}

sub find_numbers {
	my @temp = split ",", $_[0] ;
	my @TEMP ;
	foreach my $temp (@temp) {
		if ( $temp =~ /-/ ) {
			my @temp1 = split "\-", $temp ;
			for ($i=$temp1[0];$i<=$temp1[1];$i++) {
				push @TEMP , $i ;
			}
		} else {
			push @TEMP , $temp ;
		}
	}
	return (@TEMP) ;
}

return 1 ;
